VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "CellProcessor"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public countAll_ As Long
Public countInvalid_ As Long

Private fso_ As Scripting.FileSystemObject

Public Function Init()
  countAll_ = 0
  countInvalid_ = 0
  Set fso_ = New Scripting.FileSystemObject
End Function

Public Function TrimCell(target As Excel.Range)
  target = TrimWhitespace(target.Text)
End Function

Public Function TrimCellPunctuation(target As Excel.Range)
  target = TrimEndPunctuation(target.Text)
End Function

Public Function SubstituteWS(target As Excel.Range)
  target = SubstituteWhitespace(target.Text)
End Function

Public Function CreateHyperlink(target As Excel.Range)
  Call XLUpdateHyperlink(target, target.Text)
End Function

Public Function SplitTextIntoColumn(target As Excel.Range)
  Dim vWords As Variant: vWords = VBA.Split(target.Text, " ")
  If VBA.VarType(vWords) < vbArray Or VBA.VarType(vWords) > vbArray + vbByte Then _
    Call Err.Raise(1000, Description:=vWords)
  
  Dim output As Excel.Range: Set output = target
  Dim sWord As Variant
  For Each sWord In vWords
    Set output = output.Offset(1, 0)
    output = CStr(sWord)
  Next sWord
End Function

Public Function ValidateHyperlink(target As Excel.Range)
  If target.Hyperlinks.Count = 0 Then _
    Exit Function
    
  countAll_ = countAll_ + 1
  If IsValidHyperlink(target) Then
    target.Interior.ColorIndex = xlNone
  Else
    target.Interior.Color = VBA.RGB(253, 233, 217)
    countInvalid_ = countInvalid_ + 1
  End If
End Function

Public Function FixServerLink(target As Excel.Range)
  countAll_ = countAll_ + 1
  
  Dim iPath As New API_Path: Call iPath.FromString(target.Text).GlobalToServer
  If iPath.Text = target.Text Then _
    Exit Function
  
  target = iPath.Text
  Call XLUpdateHyperlink(target, iPath.Text)
  countInvalid_ = countInvalid_ + 1
End Function

' ======
Private Function IsValidHyperlink(target As Excel.Range) As Boolean
  Dim sFile$: sFile = target.Hyperlinks(1).Address
  Dim iPath As New API_Path: Call iPath.FromString(sFile).ToGlobal(target.Parent.Parent.Path)
  IsValidHyperlink = iPath.GlobalExists
End Function
  

