VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "LinksRelocator"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private fso_ As Scripting.FileSystemObject
Private prefix_ As String
Private destination_ As String
Private home_ As String
Private removeSource_ As Boolean

Public countAll_ As Long
Public countRelocated_ As Long

Public Function Init(sDestination$, sPrefix$, sHome$, bRemoveSource As Boolean)
  Set fso_ = New Scripting.FileSystemObject
  prefix_ = sPrefix
  destination_ = sDestination
  home_ = sHome
  removeSource_ = bRemoveSource
  
  countAll_ = 0
  countRelocated_ = 0
End Function

Public Function ProcessCell(target As Excel.Range)
  If target.Hyperlinks.Count = 0 Then _
    Exit Function
  
  countAll_ = countAll_ + 1
  Dim iPath As New API_Path: Call iPath.FromString(target.Value).ToGlobal(home_)
  Dim iRelativePath As API_Path: Set iRelativePath = iPath.Clone.ToLocal(prefix_)
  If iRelativePath.Text = iPath.Text Then _
    Set iRelativePath = GenerateLocalPath(iPath.FileName)
    
  If Not iPath.GlobalExists Then _
    GoTo MARK_FAILURE
    
  Dim iDestination As API_Path: Set iDestination = iRelativePath.Clone
  Call iDestination.ToGlobal(destination_)
  
  If removeSource_ Then
    If Not MoveFileOrFolder(iPath.Text, iDestination.Text, fso_) Then _
      GoTo MARK_FAILURE
  Else
    If Not CopyFileOrFolder(iPath.Text, iDestination.Text, fso_) Then _
      GoTo MARK_FAILURE
  End If
  
  target = iDestination.Text
  Call XLUpdateHyperlink(target, iDestination.Text)
  target.Interior.ColorIndex = xlNone
  countRelocated_ = countRelocated_ + 1
  Exit Function

MARK_FAILURE:
  target.Interior.Color = VBA.RGB(253, 233, 217)
End Function

' ======
Private Function GenerateLocalPath(sName$) As API_Path
  Dim iPath As New API_Path: Call iPath.FromString(sName)
  Call iPath.ToGlobal(destination_)
  Dim nCopy&: nCopy = 1
  Do While iPath.GlobalExists
    Call iPath.FromString(Fmt("{1}_{2}.{3}", iPath.BaseName, nCopy, iPath.Extension))
    Call iPath.ToGlobal(destination_)
  Loop
  Set GenerateLocalPath = iPath
End Function
