Attribute VB_Name = "PublicFunctions"
' User defined function to use in Cells formula
Option Explicit

Private Const BLANKS_LIMIT = 300

Public Sub RegisterUDF()
  Dim xlApp As Excel.Application: Set xlApp = ThisWorkbook.Application
  
  Call xlApp.MacroOptions(Macro:="RS_ToASCII", Category:="CONCEPT_RS", _
                          Description:="  Unicode  ASCII")
  Call xlApp.MacroOptions(Macro:="RS_ToMath", Category:="CONCEPT_RS", _
                          Description:="  ASCII  Unicode")
  Call xlApp.MacroOptions(Macro:="RS_ToTree", Category:="CONCEPT_RS", _
                          Description:="   ASCII    ")
                          
  Call xlApp.MacroOptions(Macro:="PY_Parse", Category:="CONCEPT_PYTHON", _
                          Description:="   " & vbNewLine & _
                          "   ,      ")
  Call xlApp.MacroOptions(Macro:="PY_Normalize", Category:="CONCEPT_PYTHON", _
                          Description:="    ")
  Call xlApp.MacroOptions(Macro:="PY_Inflect", Category:="CONCEPT_PYTHON", _
                          Description:="      ")
  Call xlApp.MacroOptions(Macro:="PY_InflectSubstitute", Category:="CONCEPT_PYTHON", _
                          Description:="   ,   " & vbNewLine & _
                          "   ,    " & vbNewLine & _
                          "   ")
  Call xlApp.MacroOptions(Macro:="PY_InflectDependant", Category:="CONCEPT_PYTHON", _
                          Description:="   ,    " & vbNewLine & _
                          "   ,     ")
  Call xlApp.MacroOptions(Macro:="PY_InflectContext", Category:="CONCEPT_PYTHON", _
                          Description:="   ,   " & vbNewLine & _
                          "     " & vbNewLine & _
                          "     ")
  Call xlApp.MacroOptions(Macro:="PY_FindSubstr", Category:="CONCEPT_PYTHON", _
                          Description:="     ")
  
  Call xlApp.MacroOptions(Macro:="CC_AbbreviateText", Category:="CONCEPT", _
                          Description:="   ")
  Call xlApp.MacroOptions(Macro:="CC_TrimWhitespace", Category:="CONCEPT", _
                          Description:="        ")
  Call xlApp.MacroOptions(Macro:="CC_TrimPunctuation", Category:="CONCEPT", _
                          Description:="     ")
  Call xlApp.MacroOptions(Macro:="CC_SubstituteWhitespace", Category:="CONCEPT", _
                          Description:="  .   ")
                          
  Call xlApp.MacroOptions(Macro:="CC_CutRight", Category:="CONCEPT", _
                          Description:="      " & vbNewLine & _
                          "cutWhat -  " & vbNewLine & _
                          "cutWhere - -" & vbNewLine & _
                          "[keepDelim=FALSE] -     ")
                                
  Call xlApp.MacroOptions(Macro:="CC_CutLeft", Category:="CONCEPT", _
                          Description:="      " & vbNewLine & _
                          "cutWhat -  " & vbNewLine & _
                          "cutWhere - -")
                                
  Call xlApp.MacroOptions(Macro:="CC_CountColor", Category:="CONCEPT", _
                          Description:="     " & vbNewLine & _
                          "rData -    " & vbNewLine & _
                          "rCriteria - ,   ")
                                
  Call xlApp.MacroOptions(Macro:="CC_FileMD5", Category:="CONCEPT", _
                          Description:=" -    MD5")
  Call xlApp.MacroOptions(Macro:="CC_FileSHA1", Category:="CONCEPT", _
                          Description:=" -    SAH1")
                                
  Call xlApp.MacroOptions(Macro:="CC_ExtactFileName", Category:="CONCEPT", _
                          Description:="  ")
  Call xlApp.MacroOptions(Macro:="CC_ExtactFileNameText", Category:="CONCEPT", _
                          Description:="    ")
  Call xlApp.MacroOptions(Macro:="CC_ExtactFileExtension", Category:="CONCEPT", _
                          Description:="  ")
  Call xlApp.MacroOptions(Macro:="CC_ExtactFolderName", Category:="CONCEPT", _
                          Description:=" ,  ")
                          
  Call xlApp.MacroOptions(Macro:="CC_HyperlinkToString", Category:="CONCEPT", _
                          Description:="   ")
                          
  Call xlApp.MacroOptions(Macro:="CC_MatchCount", Category:="CONCEPT", _
                          Description:="      ")
  Call xlApp.MacroOptions(Macro:="CC_MatchMultiple", Category:="CONCEPT", _
                          Description:="   ,   " & vbNewLine & _
                          "target -   " & vbNewLine & _
                          "iMatchList -  " & vbNewLine & _
                          "[nMode=1] -  " & vbNewLine & _
                          "1 - ( ) -   " & vbNewLine & _
                          "2 -  " & vbNewLine & _
                          "3 -  " & vbNewLine & _
                          "4 -    ")
  Call xlApp.MacroOptions(Macro:="CC_LookupSubstr", Category:="CONCEPT", _
                          Description:="  (HLOOKUP),       ,   ")
  Call xlApp.MacroOptions(Macro:="CC_LongestDuplicatePrefix", Category:="CONCEPT", _
                          Description:="  ,     2    ")
  Call xlApp.MacroOptions(Macro:="CC_LongestDuplicateSuffix", Category:="CONCEPT", _
                          Description:="  ,     2    ")
  Call xlApp.MacroOptions(Macro:="CC_SLOW_LongestDuplicateSubstring", Category:="CONCEPT", _
                          Description:="  ,     2    " & vbNewLine & _
                          "!           ")
                          
  Call xlApp.MacroOptions(Macro:="CC_LookupMulti", Category:="CONCEPT", _
                          Description:="      1         2." & vbNewLine & _
                                      "      =  3  ,         2")
  Call xlApp.MacroOptions(Macro:="CC_LookupMultiCount", Category:="CONCEPT", _
                          Description:="   LookupMulti,     ")
  Call xlApp.MacroOptions(Macro:="CC_LookupMultiAll", Category:="CONCEPT", _
                          Description:="   LookupMulti,        ")
End Sub

Public Sub UnregisterUDF()
  Call UnregisterMacto("RS_ToASCII")
  Call UnregisterMacto("RS_ToMath")
  Call UnregisterMacto("RS_ToTree")
  Call UnregisterMacto("PY_Parse")
  Call UnregisterMacto("PY_Normalize")
  Call UnregisterMacto("PY_Inflect")
  Call UnregisterMacto("PY_InflectSubstitute")
  Call UnregisterMacto("PY_InflectContext")
  Call UnregisterMacto("PY_InflectDependant")
  Call UnregisterMacto("PY_FindSubstr")
  Call UnregisterMacto("CC_AbbreviateText")
  Call UnregisterMacto("CC_TrimWhitespace")
  Call UnregisterMacto("CC_TrimPunctuation")
  Call UnregisterMacto("CC_CutRight")
  Call UnregisterMacto("CC_CutLeft")
  Call UnregisterMacto("CC_CountColor")
  Call UnregisterMacto("CC_FileMD5")
  Call UnregisterMacto("CC_FileSHA1")
  Call UnregisterMacto("CC_ExtactFileName")
  Call UnregisterMacto("CC_ExtactFileNameText")
  Call UnregisterMacto("CC_ExtactFileExtension")
  Call UnregisterMacto("CC_ExtactFolderName")
  Call UnregisterMacto("CC_HyperlinkToString")
  Call UnregisterMacto("CC_SubstituteWhitespace")
  Call UnregisterMacto("CC_MatchCount")
  Call UnregisterMacto("CC_MatchMultiple")
  Call UnregisterMacto("CC_LookupSubstr")
  Call UnregisterMacto("CC_LongestDuplicatePrefix")
  Call UnregisterMacto("CC_LongestDuplicateSuffix")
  Call UnregisterMacto("CC_SLOW_LongestDuplicateSubstring")
  Call UnregisterMacto("CC_LookupMulti")
  Call UnregisterMacto("CC_LookupMulti")
  Call UnregisterMacto("CC_LookupMultiCount")
  Call UnregisterMacto("CC_LookupMultiAll")
End Sub

Public Function RS_ToASCII(sUnicodeText$) As String
Attribute RS_ToASCII.VB_Description = "  Unicode  ASCII"
Attribute RS_ToASCII.VB_ProcData.VB_Invoke_Func = " \n20"
  RS_ToASCII = MathToASCII(sUnicodeText)
End Function

Public Function RS_ToMath(sAsciiText$) As String
Attribute RS_ToMath.VB_Description = "  ASCII  Unicode"
Attribute RS_ToMath.VB_ProcData.VB_Invoke_Func = " \n20"
  RS_ToMath = ASCIItoMath(sAsciiText)
End Function

Public Function RS_ToTree(sAsciiText$) As String
Attribute RS_ToTree.VB_Description = "   ASCII    "
Attribute RS_ToTree.VB_ProcData.VB_Invoke_Func = " \n20"
  RS_ToTree = ASCIItoAST(sAsciiText)
End Function

Public Function PY_Parse(sTarget$, Optional sTags$ = "") As String
Attribute PY_Parse.VB_Description = "   \r\n   ,      "
Attribute PY_Parse.VB_ProcData.VB_Invoke_Func = " \n21"
  PY_Parse = AccessPython.CallFunction(PY_MODULE_TEXT, "parse", Array(sTarget, sTags))
End Function

Public Function PY_Normalize(sTarget$) As String
Attribute PY_Normalize.VB_Description = "    "
Attribute PY_Normalize.VB_ProcData.VB_Invoke_Func = " \n21"
  PY_Normalize = AccessPython.CallFunction(PY_MODULE_TEXT, "normalize", Array(sTarget))
End Function

Public Function PY_Inflect(sTarget$, sTags$) As String
Attribute PY_Inflect.VB_Description = "      "
Attribute PY_Inflect.VB_ProcData.VB_Invoke_Func = " \n21"
  PY_Inflect = AccessPython.CallFunction(PY_MODULE_TEXT, "inflect", Array(sTarget, sTags))
End Function

Public Function PY_InflectSubstitute(sTarget$, sOriginal$) As String
Attribute PY_InflectSubstitute.VB_Description = "   ,   \r\n   ,    \r\n   "
Attribute PY_InflectSubstitute.VB_ProcData.VB_Invoke_Func = " \n21"
  PY_InflectSubstitute = AccessPython.CallFunction(PY_MODULE_TEXT, "inflect_substitute", Array(sTarget, sOriginal))
End Function

Public Function PY_InflectDependant(sTarget$, sMaster$) As String
Attribute PY_InflectDependant.VB_Description = "   ,    \r\n   ,     "
Attribute PY_InflectDependant.VB_ProcData.VB_Invoke_Func = " \n21"
  PY_InflectDependant = AccessPython.CallFunction(PY_MODULE_TEXT, "inflect_dependant", Array(sTarget, sMaster))
End Function

Public Function PY_InflectContext(sTarget$, Optional sBefore$ = "", Optional sAfter$ = "") As String
Attribute PY_InflectContext.VB_Description = "   ,   \r\n     \r\n     "
Attribute PY_InflectContext.VB_ProcData.VB_Invoke_Func = " \n21"
  PY_InflectContext = AccessPython.CallFunction(PY_MODULE_TEXT, "inflect_context", Array(sTarget, sBefore, sAfter))
End Function

Public Function PY_FindSubstr(sHaystack$, sNeedle$) As String
Attribute PY_FindSubstr.VB_Description = "     "
Attribute PY_FindSubstr.VB_ProcData.VB_Invoke_Func = " \n21"
  Dim result As Variant:
  result = AccessPython.CallFunction(PY_MODULE_TEXT, "find_substr", Array(sHaystack, sNeedle))
  PY_FindSubstr = Fmt("{1},{2}", result(0), result(1))
End Function

Public Function CC_AbbreviateText(target$) As String
Attribute CC_AbbreviateText.VB_Description = "   "
Attribute CC_AbbreviateText.VB_ProcData.VB_Invoke_Func = " \n22"
  CC_AbbreviateText = ApplyCommonAbbreviations(target)
End Function

Public Function CC_TrimWhitespace(target$) As String
Attribute CC_TrimWhitespace.VB_Description = "        "
Attribute CC_TrimWhitespace.VB_ProcData.VB_Invoke_Func = " \n22"
  CC_TrimWhitespace = TrimWhitespace(target)
End Function

Public Function CC_TrimPunctuation(target$) As String
Attribute CC_TrimPunctuation.VB_Description = "     "
Attribute CC_TrimPunctuation.VB_ProcData.VB_Invoke_Func = " \n22"
  CC_TrimPunctuation = TrimEndPunctuation(target)
End Function

Public Function CC_CutRight(cutWhat$, cutWhere$, Optional keepDelim As Boolean = False) As String
Attribute CC_CutRight.VB_Description = "      \r\ncutWhat -  \r\ncutWhere - -\r\n[keepDelim=FALSE] -     "
Attribute CC_CutRight.VB_ProcData.VB_Invoke_Func = " \n22"
'          
  Dim nPos&: nPos = VBA.InStr(1, cutWhat, cutWhere)
  If nPos = 0 Then _
    Exit Function
  If keepDelim Then
    CC_CutRight = VBA.Right(cutWhat, VBA.Len(cutWhat) - nPos + 1)
  Else
    CC_CutRight = VBA.Right(cutWhat, VBA.Len(cutWhat) - nPos + 1 - VBA.Len(cutWhere))
  End If
End Function

Public Function CC_CutLeft(cutWhat$, cutWhere$) As String
Attribute CC_CutLeft.VB_Description = "      \r\ncutWhat -  \r\ncutWhere - -"
Attribute CC_CutLeft.VB_ProcData.VB_Invoke_Func = " \n22"
'          
  CC_CutLeft = cutWhat
  Dim nPos&: nPos = VBA.InStr(1, cutWhat, cutWhere)
  If nPos = 0 Then _
    Exit Function
  CC_CutLeft = VBA.Left(cutWhat, nPos - 1)
End Function

Public Function CC_CountColor(rData As Excel.Range, rCriteria As Excel.Range) As Long
Attribute CC_CountColor.VB_Description = "     \r\nrData -    \r\nrCriteria - ,   "
Attribute CC_CountColor.VB_ProcData.VB_Invoke_Func = " \n22"
  Dim aCell As Excel.Range
  Dim xcolor&: xcolor = rCriteria.Interior.ColorIndex
  For Each aCell In rData
    If aCell.Interior.ColorIndex = xcolor Then _
      CC_CountColor = CC_CountColor + 1
  Next aCell
End Function

Public Function CC_FileMD5(sPath$) As String
Attribute CC_FileMD5.VB_Description = " -    MD5"
Attribute CC_FileMD5.VB_ProcData.VB_Invoke_Func = " \n22"
  CC_FileMD5 = FileToMD5(sPath)
  If CC_FileMD5 = vbNullString Then _
    CC_FileMD5 = "File not found"
End Function

Public Function CC_FileSHA1(sPath$) As String
Attribute CC_FileSHA1.VB_Description = " -    SAH1"
Attribute CC_FileSHA1.VB_ProcData.VB_Invoke_Func = " \n22"
  CC_FileSHA1 = FileToSHA1(sPath)
  If CC_FileSHA1 = vbNullString Then _
    CC_FileSHA1 = "File not found"
End Function

Public Function CC_ExtactFileName(sPath$) As String
Attribute CC_ExtactFileName.VB_Description = "  "
Attribute CC_ExtactFileName.VB_ProcData.VB_Invoke_Func = " \n22"
  Dim fso As New Scripting.FileSystemObject
  CC_ExtactFileName = fso.GetFileName(sPath)
End Function

Public Function CC_ExtactFileNameText(sPath$) As String
Attribute CC_ExtactFileNameText.VB_Description = "    "
Attribute CC_ExtactFileNameText.VB_ProcData.VB_Invoke_Func = " \n22"
  Dim fso As New Scripting.FileSystemObject
  CC_ExtactFileNameText = fso.GetBaseName(sPath)
End Function

Public Function CC_ExtactFileExtension(sPath$) As String
Attribute CC_ExtactFileExtension.VB_Description = "  "
Attribute CC_ExtactFileExtension.VB_ProcData.VB_Invoke_Func = " \n22"
  Dim fso As New Scripting.FileSystemObject
  CC_ExtactFileExtension = fso.GetExtensionName(sPath)
End Function

Public Function CC_ExtactFolderName(sPath$) As String
Attribute CC_ExtactFolderName.VB_Description = " ,  "
Attribute CC_ExtactFolderName.VB_ProcData.VB_Invoke_Func = " \n22"
  Dim fso As New Scripting.FileSystemObject
  CC_ExtactFolderName = fso.GetParentFolderName(sPath)
End Function

Public Function CC_HyperlinkToString(aCell As Excel.Range) As String
Attribute CC_HyperlinkToString.VB_Description = "   "
Attribute CC_HyperlinkToString.VB_ProcData.VB_Invoke_Func = " \n22"
  If aCell.Hyperlinks.Count > 0 Then
  With aCell.Hyperlinks(1)
    CC_HyperlinkToString = .Address
    If .SubAddress <> vbNullString Then _
      CC_HyperlinkToString = CC_HyperlinkToString + "#" + .SubAddress
  End With
  End If
End Function

Public Function CC_SubstituteWhitespace(target$) As String
Attribute CC_SubstituteWhitespace.VB_Description = "  .   "
Attribute CC_SubstituteWhitespace.VB_ProcData.VB_Invoke_Func = " \n22"
  CC_SubstituteWhitespace = SubstituteWhitespace(target)
End Function

Public Function CC_MatchCount(target$, iMatch$) As Long
Attribute CC_MatchCount.VB_Description = "      "
Attribute CC_MatchCount.VB_ProcData.VB_Invoke_Func = " \n22"
  CC_MatchCount = (VBA.Len(target) - VBA.Len(VBA.Replace(target, iMatch, "", Compare:=vbTextCompare))) / VBA.Len(iMatch)
End Function

Public Function CC_MatchMultiple(target$, iMatchList As Excel.Range, Optional nMode As TMatchMode = T_MM_DEFAULT) As String
Attribute CC_MatchMultiple.VB_Description = "   ,   \r\ntarget -   \r\niMatchList -  \r\n[nMode=1] -  \r\n1 - ( ) -   \r\n2 -  \r\n3 -  \r\n4 -    "
Attribute CC_MatchMultiple.VB_ProcData.VB_Invoke_Func = " \n22"
  Dim aCell As Excel.Range
  Dim sMatch$
  Dim sTarget$: sTarget = ApplyMatchMode(target, nMode)
  For Each aCell In iMatchList
    Dim sText$: sText = ApplyMatchMode(aCell.Text, nMode)
    If VBA.InStr(1, sTarget, sText, vbTextCompare) <> 0 Then
      If sMatch <> vbNullString Then _
        sMatch = sMatch & ";"
      sMatch = sMatch & aCell
    End If
  Next aCell
  CC_MatchMultiple = sMatch
End Function

Public Function CC_LookupSubstr(sSearch$, iData As Excel.Range, nColumn&) As Variant
Attribute CC_LookupSubstr.VB_Description = "  (HLOOKUP),       ,   "
Attribute CC_LookupSubstr.VB_ProcData.VB_Invoke_Func = " \n22"
  If nColumn > iData.Columns.Count Then
    CC_LookupSubstr = CVErr(xlErrValue)
    Exit Function
  End If
  
  Dim aCell As Excel.Range
  Dim nBlank&: nBlank = 0
  For Each aCell In iData.Columns(1).Cells
    Dim sText$: sText = aCell.Text
    If sText = "" Then
      nBlank = nBlank + 1
      If nBlank > BLANKS_LIMIT Then _
        Exit Function
    Else
      nBlank = 0
    End If
    
    If VBA.InStr(1, sText, sSearch, vbTextCompare) <> 0 Then
      CC_LookupSubstr = aCell.Offset(0, nColumn - 1).Text
      Exit Function
    End If
  Next aCell
End Function

Public Function CC_LongestDuplicateSuffix(iData As Excel.Range, Optional nMaxLen& = 1000) As String
Attribute CC_LongestDuplicateSuffix.VB_Description = "  ,     2    "
Attribute CC_LongestDuplicateSuffix.VB_ProcData.VB_Invoke_Func = " \n22"
  Dim arrValue As Variant
  arrValue = iData.Value
  If ArraySize(arrValue, 2) <> 1 Then
    CC_LongestDuplicateSuffix = CVErr(xlErrValue)
    Exit Function
  End If
  If ArraySize(arrValue, 1) = 1 Then
    CC_LongestDuplicateSuffix = ""
    Exit Function
  End If
  
  Dim sInputs() As String: ReDim sInputs(1 To UBound(arrValue))
  Dim nLens() As Long: ReDim nLens(1 To UBound(arrValue))
  Dim nItem&
  Dim nOut&: nOut = 1
  Dim sCurrent$
  Dim nCurrentLen&: nCurrentLen = 0
  For nItem = 1 To UBound(arrValue)
    sInputs(nOut) = VBA.Right$(CStr(arrValue(nItem, 1)), nMaxLen)
    nLens(nOut) = VBA.Len(sInputs(nOut))
    If nLens(nOut) <= nCurrentLen Then _
      GoTo NEXT_ITEM
    If nOut = 1 Then
      nOut = nOut + 1
      GoTo NEXT_ITEM
    End If
      
    Dim nCompare&
    For nCompare = 1 To nOut - 1 Step 1
      If nLens(nCompare) <= nCurrentLen Then _
        GoTo NEXT_COMPARE
      If VBA.Right$(sInputs(nOut), nCurrentLen + 1) <> VBA.Right$(sInputs(nCompare), nCurrentLen + 1) Then _
        GoTo NEXT_COMPARE
      
      Do
        nCurrentLen = nCurrentLen + 1
        If nLens(nCompare) <= nCurrentLen Or nLens(nOut) <= nCurrentLen Then _
          Exit Do
        If VBA.Mid$(sInputs(nOut), nLens(nOut) - nCurrentLen, 1) <> VBA.Mid$(sInputs(nCompare), nLens(nCompare) - nCurrentLen, 1) Then _
          Exit Do
      Loop
      
      sCurrent = VBA.Right$(sInputs(nOut), nCurrentLen)
NEXT_COMPARE:
    Next nCompare

    nOut = nOut + 1
NEXT_ITEM:
  Next nItem
  
  CC_LongestDuplicateSuffix = sCurrent
End Function

Public Function CC_LongestDuplicatePrefix(iData As Excel.Range, Optional nMaxLen& = 1000) As String
Attribute CC_LongestDuplicatePrefix.VB_Description = "  ,     2    "
Attribute CC_LongestDuplicatePrefix.VB_ProcData.VB_Invoke_Func = " \n22"
  Dim arrValue As Variant
  arrValue = iData.Value
  If ArraySize(arrValue, 2) <> 1 Then
    CC_LongestDuplicatePrefix = CVErr(xlErrValue)
    Exit Function
  End If
  If ArraySize(arrValue, 1) = 1 Then
    CC_LongestDuplicatePrefix = ""
    Exit Function
  End If
  
  Dim sInputs() As String: ReDim sInputs(1 To UBound(arrValue))
  Dim nLens() As Long: ReDim nLens(1 To UBound(arrValue))
  Dim nItem&
  Dim nOut&: nOut = 1
  Dim sCurrent$
  Dim nCurrentLen&: nCurrentLen = 0
  For nItem = 1 To UBound(arrValue)
    sInputs(nOut) = VBA.Left$(CStr(arrValue(nItem, 1)), nMaxLen)
    nLens(nOut) = VBA.Len(sInputs(nOut))
    If nLens(nOut) <= nCurrentLen Then _
      GoTo NEXT_ITEM
    If nOut = 1 Then
      nOut = nOut + 1
      GoTo NEXT_ITEM
    End If
      
    Dim nCompare&
    For nCompare = 1 To nOut - 1 Step 1
      If nLens(nCompare) <= nCurrentLen Then _
        GoTo NEXT_COMPARE
      If VBA.Left$(sInputs(nOut), nCurrentLen + 1) <> VBA.Left$(sInputs(nCompare), nCurrentLen + 1) Then _
        GoTo NEXT_COMPARE
      
      Do
        nCurrentLen = nCurrentLen + 1
        If nLens(nCompare) <= nCurrentLen Or nLens(nOut) <= nCurrentLen Then _
          Exit Do
        If VBA.Mid$(sInputs(nOut), nCurrentLen + 1, 1) <> VBA.Mid$(sInputs(nCompare), nCurrentLen + 1, 1) Then _
          Exit Do
      Loop
      
      sCurrent = VBA.Left$(sInputs(nOut), nCurrentLen)
NEXT_COMPARE:
    Next nCompare

    nOut = nOut + 1
NEXT_ITEM:
  Next nItem
  
  CC_LongestDuplicatePrefix = sCurrent
End Function

Public Function CC_SLOW_LongestDuplicateSubstring(iData As Excel.Range) As String
Attribute CC_SLOW_LongestDuplicateSubstring.VB_Description = "  ,     2    \r\n!           "
Attribute CC_SLOW_LongestDuplicateSubstring.VB_ProcData.VB_Invoke_Func = " \n22"
  Dim arrValue As Variant
  arrValue = iData.Value
  If ArraySize(arrValue, 2) <> 1 Then
    CC_SLOW_LongestDuplicateSubstring = "ERR"
    Exit Function
  End If
  If ArraySize(arrValue, 1) = 1 Then
    CC_SLOW_LongestDuplicateSubstring = ""
    Exit Function
  End If
  
  Dim sInputs() As String: ReDim sInputs(1 To UBound(arrValue))
  Dim nLens() As Long: ReDim nLens(1 To UBound(arrValue))
  Dim nItem&
  For nItem = 1 To UBound(arrValue)
    sInputs(nItem) = CStr(arrValue(nItem, 1))
    nLens(nItem) = VBA.Len(sInputs(nItem))
  Next nItem
  
  CC_SLOW_LongestDuplicateSubstring = RunLCS(sInputs, nLens)
End Function

Public Function CC_LookupMulti(iData As Excel.Range, sText$, nResultColumn&) As Variant
Attribute CC_LookupMulti.VB_Description = "      1         2.\r\n      =  3  ,         2"
Attribute CC_LookupMulti.VB_ProcData.VB_Invoke_Func = " \n22"
  If nResultColumn > iData.Columns.Count Then
    CC_LookupMulti = CVErr(xlErrValue)
    Exit Function
  End If
  
  Dim aCell As Excel.Range
  Dim nBlank&: nBlank = 0
  For Each aCell In iData.Columns(1).Cells
    Dim sSearch$: sSearch = aCell.Text
    If sSearch = "" Then
      nBlank = nBlank + 1
      If nBlank > BLANKS_LIMIT Then _
        Exit Function
    Else
      nBlank = 0
    End If
    
    If VBA.InStr(1, sText, sSearch, vbTextCompare) <> 0 Then
      CC_LookupMulti = aCell.Offset(0, nResultColumn - 1).Text
      Exit Function
    End If
  Next aCell
  CC_LookupMulti = ""
End Function

Public Function CC_LookupMultiCount(iData As Excel.Range, sText$) As Variant
Attribute CC_LookupMultiCount.VB_Description = "   LookupMulti,     "
Attribute CC_LookupMultiCount.VB_ProcData.VB_Invoke_Func = " \n22"
  Dim aCell As Excel.Range
  Dim nBlank&: nBlank = 0
  CC_LookupMultiCount = 0
  For Each aCell In iData.Columns(1).Cells
    Dim sSearch$: sSearch = aCell.Text
    If sSearch = "" Then
      nBlank = nBlank + 1
      If nBlank > BLANKS_LIMIT Then _
        Exit Function
    Else
      nBlank = 0
    End If
    
    If VBA.InStr(1, sText, sSearch, vbTextCompare) <> 0 Then
      CC_LookupMultiCount = CC_LookupMultiCount + 1
    End If
  Next aCell
End Function

Public Function CC_LookupMultiAll(iData As Excel.Range, sText$, nResultColumn&) As Variant
Attribute CC_LookupMultiAll.VB_Description = "   LookupMulti,        "
Attribute CC_LookupMultiAll.VB_ProcData.VB_Invoke_Func = " \n22"
  If nResultColumn > iData.Columns.Count Then
    CC_LookupMultiAll = CVErr(xlErrValue)
    Exit Function
  End If
  
  Dim aCell As Excel.Range
  Dim nBlank&: nBlank = 0
  CC_LookupMultiAll = ""
  For Each aCell In iData.Columns(1).Cells
    Dim sSearch$: sSearch = aCell.Text
    If sSearch = "" Then
      nBlank = nBlank + 1
      If nBlank > BLANKS_LIMIT Then _
        Exit Function
    Else
      nBlank = 0
    End If
    
    If VBA.InStr(1, sText, sSearch, vbTextCompare) <> 0 Then
      If CC_LookupMultiAll <> "" Then _
        CC_LookupMultiAll = CC_LookupMultiAll & ";"
      CC_LookupMultiAll = CC_LookupMultiAll & aCell.Offset(0, nResultColumn - 1)
    End If
  Next aCell
End Function

' =======
Private Function UnregisterMacto(sMacro$)
  On Error Resume Next
  Call Excel.Application.MacroOptions(Macro:=sMacro, Category:=Empty, Description:=Empty)
End Function

Private Function ApplyMatchMode(sText$, nMode As TMatchMode) As String
  Select Case nMode
  Case T_MM_DEFAULT: ApplyMatchMode = sText
  Case T_MM_SPACE_LEFT: ApplyMatchMode = " " & sText
  Case T_MM_SPACE_RIGHT: ApplyMatchMode = sText & " "
  Case T_MM_SPACE_BOTH: ApplyMatchMode = " " & sText & " "
  End Select
End Function

Private Function RunLCS(sInputs() As String, nLens() As Long) As String
  Dim sCurrent$
  Dim nCurrentLen&: nCurrentLen = 0
  
  Dim nSample&
  For nSample = 1 To UBound(sInputs) - 1 Step 1
    Dim nSampleLen&: nSampleLen = nLens(nSample)
    If nSampleLen <= nCurrentLen Then _
      GoTo NEXT_SAMPLE
    
    Dim nSubstr&
    Dim nPos&
    Dim nCompare&
    For nSubstr = nSampleLen To nCurrentLen + 1 Step -1
      For nPos = 1 To nSampleLen - nSubstr + 1 Step 1
        Dim sSample$: sSample = VBA.Mid$(sInputs(nSample), nPos, nSampleLen)
        For nCompare = nSample + 1 To UBound(sInputs) Step 1
          If nLens(nCompare) < nSampleLen Then _
            GoTo NEXT_COMPARE
          Dim nFound&: nFound = VBA.InStr(nPos, sInputs(nCompare), sSample, vbTextCompare)
          If nFound <> 0 Then
            nCurrentLen = nSubstr
            sCurrent = sSample
            GoTo NEXT_SAMPLE
          End If
NEXT_COMPARE:
        Next nCompare
      Next nPos
    Next nSubstr
NEXT_SAMPLE:
  Next nSample
  
  RunLCS = sCurrent
End Function
