VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} SearchDlg 
   Caption         =   " "
   ClientHeight    =   5370
   ClientLeft      =   120
   ClientTop       =   465
   ClientWidth     =   4575
   OleObjectBlob   =   "SearchDlg.frx":0000
   StartUpPosition =   1  'CenterOwner
End
Attribute VB_Name = "SearchDlg"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Public isCancelled_ As Boolean

Private dataSource_ As Excel.Workbook

Public Function Init(targetWB As Excel.Workbook)
  isCancelled_ = True
  Set dataSource_ = targetWB
End Function

Public Function ResultParams() As ParametersSearch
  Set ResultParams = New ParametersSearch
  With ResultParams
    .ignoreSmall_ = CBIgnoreWords.Value
    .partialMatch_ = Not CBFindWhole.Value
    .normalize_ = CBNormalize.Value
    .outputText_ = CBOutputText.Value
    .smallSize_ = TBSymbolLimit.Value
    Set .searchWhere_ = Excel.Range(TBSearchRange.Text)
    Set .searchWhat_ = Excel.Range(TBQueryRange.Text)
  End With
End Function

Private Sub BtnCancel_Click()
  isCancelled_ = True
  Call Me.Hide
End Sub

Private Sub BtnOK_Click()
  If Not ValidateData Then
    Call UserInteraction.ShowMessage(EM_DIALOG_DATA_INVALID)
  Else
    isCancelled_ = False
    Call Me.Hide
  End If
End Sub

Private Sub BtnSearchRange_Click()
  Call Me.Hide
  
  Dim iRange As Excel.Range
  On Error Resume Next
  Set iRange = Excel.Application.InputBox( _
    Title:="  ", _
    Prompt:=" ,     ", _
    Type:=8)
  On Error GoTo 0
  
  If Not iRange Is Nothing Then _
    TBSearchRange.Text = iRange.Address(External:=True)
  
  Call Me.Show
End Sub

Private Sub BtnQueryRange_Click()
  Call Me.Hide
  
  Dim iRange As Excel.Range
  On Error Resume Next
  Set iRange = Excel.Application.InputBox( _
    Title:="  ", _
    Prompt:=" ,   ", _
    Type:=8)
  On Error GoTo 0
  
  If Not iRange Is Nothing Then _
    TBQueryRange.Text = iRange.Address(External:=True)
  
  Call Me.Show
End Sub

' ========
Private Function ValidateData() As Boolean
  ValidateData = False
  If TBQueryRange.Text = vbNullString Then _
    Exit Function
  If TBSearchRange.Text = vbNullString Then _
    Exit Function
  ValidateData = True
End Function
