Attribute VB_Name = "z_UIMessages"
' Messaging module
Option Private Module
Option Explicit

Public Enum MsgCode
  EM_PROJECTS_EMPTY
  EM_SELECTION_NO_HYPERLINKS
  EM_SELECTION_EMPTY
  EM_RELOCATE_DATA_FAIL
  EM_WORD_IS_OPEN
  EM_CORE_UPDATE_FAILED
  EM_WORD_ADDINS_FAILED
  EM_TEMPLATES_FAILED
  EM_DIALOG_DATA_INVALID
  
  IM_LINKS_VALIDATION
  IM_LINKS_SERVER
  IM_LINKS_SCAN_OK
  IM_LINKS_RELOCATE_OK
  IM_CONCEPT_UPDATE_OK
  IM_WORD_ADDINS_OK
  IM_TEMPLATES_OK
  IM_LINKS_COPY_OK
  IM_SEARCH_OK
End Enum

Private g_UI As API_UserInteraction

Public Function UserInteraction() As API_UserInteraction
  If g_UI Is Nothing Then _
    Set g_UI = New API_UserInteraction
  Set UserInteraction = g_UI
End Function

Public Function SetUserInteraction(newUI As API_UserInteraction)
  Set g_UI = newUI
End Function

Public Function UIShowMessage(theCode As MsgCode, ParamArray params() As Variant)
  Dim unwrapped As Variant: unwrapped = params
  unwrapped = FixForwardedParams(unwrapped)
  
  Select Case theCode
  Case EM_PROJECTS_EMPTY:             Call MsgBox("  ", vbExclamation)
  Case EM_SELECTION_NO_HYPERLINKS:    Call MsgBox("    ", vbExclamation)
  Case EM_SELECTION_EMPTY:            Call MsgBox("  ", vbExclamation)
  Case EM_RELOCATE_DATA_FAIL:         Call MsgBox("   ", vbExclamation)
  Case EM_WORD_IS_OPEN:               Call MsgBox(" Word     ", vbExclamation)
  Case EM_CORE_UPDATE_FAILED:         Call MsgBox("      ." & vbNewLine _
                                                  & " VPN,   (\\fs1.concept.ru)" & vbNewLine _
                                                  & "  Excel   dll", vbExclamation)
  Case EM_WORD_ADDINS_FAILED:         Call MsgBox("   .    \\fs1.concept.ru", vbExclamation)
  Case EM_TEMPLATES_FAILED:           Call MsgBox("   ", vbExclamation)
  Case EM_DIALOG_DATA_INVALID:        Call MsgBox("   ", vbExclamation)
  
  Case IM_LINKS_VALIDATION:           Call MsgBox(Fmt("    : {1}/{2}", unwrapped), vbInformation)
  Case IM_LINKS_SCAN_OK:              Call MsgBox(Fmt(" : {1}/{2}", unwrapped), vbInformation)
  Case IM_LINKS_RELOCATE_OK:          Call MsgBox(Fmt(" : {1}/{2}", unwrapped), vbInformation)
  Case IM_LINKS_SERVER:               Call MsgBox(Fmt(" : {1}/{2}", unwrapped), vbInformation)
  Case IM_CONCEPT_UPDATE_OK:           Call MsgBox("    ", vbInformation)
  Case IM_WORD_ADDINS_OK:             Call MsgBox("  ", vbInformation)
  Case IM_TEMPLATES_OK:               Call MsgBox("  ", vbInformation)
  Case IM_LINKS_COPY_OK:              Call MsgBox(Fmt(" : {1}/{2}", unwrapped), vbInformation)
  Case IM_SEARCH_OK:                   Call MsgBox(" ", vbInformation)
  
  Case Else:                          Call MsgBox("  ", vbCritical)
  End Select
End Function

Public Function UIAskQuestion(theCode As MsgCode, ParamArray params() As Variant) As Boolean
  Dim unwrapped As Variant: unwrapped = params
  unwrapped = FixForwardedParams(unwrapped)
  
  Dim answer&: answer = vbNo
  Select Case theCode
  'Case QM_CODE_DELETE_CONFIRM
  '  answer = MsgBox("Are you sure you want to delete ALL macros from target file?", vbYesNo + vbQuestion)
    
  Case Else
    Call MsgBox("  ", vbCritical)
  End Select
  UIAskQuestion = answer = vbYes
End Function
